/*
 * Marcin Owsiany  8:00
 * 2 10.11.2000
 * 1 4
 */

#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdlib.h>
#include <ftw.h>

char *destdir = "";
char *srcdir = "";
char fname[1024];
char *buff;
int bs = 0;

int filecpy(const char *file, const struct stat *st, int flags)
{
	int sfd, dfd, n, c;
	FILE *sst, *dst;
	
	if (flags == FTW_NS) {
		perror(file);
		return 1;
	}
	strcpy(fname+strlen(destdir), file+strlen(srcdir));
	if (S_ISREG(st->st_mode)) {
		if (bs) {
			if ((sfd = open(file, O_RDONLY)) == -1) {
				perror(file);
				return 1;
			}
			if ((dfd = open(fname, O_WRONLY|O_CREAT|O_EXCL, st->st_mode)) == -1) {
				perror(fname);
				return 1;
			}
			while((n = read(sfd, buff, bs)) > 0)
				write(dfd, buff, n);
			if (close(sfd) == -1) {
				perror(file);
				return 1;
			}
			if (close(dfd) == -1) {
				perror(fname);
				return 1;
			}
		} else {
			if ((sst = fopen(file, "r")) == NULL ) {
				perror(file);
				return 1;
			}
			if ((dst = fopen(fname, "w")) == NULL) {
				perror(fname);
				return 1;
			}
			while ((c = getc(sst)) != EOF)
				putc(c, dst);
				
			if (fclose(dst) != 0) {
				perror(fname);
				return 1;
			}
			if (fclose(sst) != 0) {
				perror(file);
				return 1;
			}
		}
	} else if (S_ISDIR(st->st_mode))
		if (mkdir(fname, st->st_mode) == -1) {
			perror(file);
			return 1;
		}
	return 0;
}

int onefilecpy(const char *from, const char *to, const struct stat *st)
{
	int sfd, dfd, n, c;
	FILE *sst, *dst;
	
	if (bs) {
		if ((sfd = open(from, O_RDONLY)) == -1) {
			perror(from);
			return 1;
		}
		if ((dfd = open(to, O_WRONLY|O_CREAT|O_EXCL, st->st_mode)) == -1) {
			perror(to);
			return 1;
		}
		while((n = read(sfd, buff, bs)) > 0)
			write(dfd, buff, n);
		if (close(sfd) == -1) {
			perror(from);
			return 1;
		}
		if (close(dfd) == -1) {
			perror(to);
			return 1;
		}
	} else {
		if ((sst = fopen(from, "r")) == NULL ) {
			perror(from);
			return 1;
		}
		if ((dst = fopen(to, "w")) == NULL) {
			perror(to);
			return 1;
		}
		while ((c = getc(sst)) != EOF)
			putc(c, dst);
		if (fclose(dst) != 0) {
			perror(to);
			return 1;
		}
		if (fclose(sst) != 0) {
			perror(from);
			return 1;
		}
	}
	return 0;
}

int cpy(char *from, char *to)
{
	struct stat st;
	
	if (stat(to, &st) != -1) {
		fprintf(stderr, "%s istnieje", to);
		exit(EXIT_FAILURE);
	}

	if (stat(from, &st) != 0) {
		perror(from);
		exit(EXIT_FAILURE);
	}


	if (S_ISDIR(st.st_mode)) {
		destdir = malloc(strlen(to));
		srcdir  = malloc(strlen(from));
		strcpy(destdir, to);
		strcpy(srcdir,  from);
		strcpy(fname,   to);
		if (ftw(from, filecpy, 100)) {
			fprintf(stderr, "Blad w czasie przechodzenia katalogu %s\n", from);
			exit(EXIT_FAILURE);
		}
	} else if (S_ISREG(st.st_mode)) {
		if (onefilecpy(from, to, &st)) {
			fprintf(stderr, "Blad w czasie kopiowania pliku %s\n", from);
			exit(EXIT_FAILURE);
		}
	}
	else {
		fprintf(stderr, "%s nie jest plikiem ani katalogiem\n", from);
		exit(EXIT_FAILURE);
	}
	return 1;
}


int main(int argc, char **argv)
{
	char options[] = "s:";
	char c;
	
	while ((c = getopt(argc, argv, options)) != -1) {
		if (c == 's') {
			bs = atoi(optarg);
			if ((buff = malloc(bs)) == NULL) {
				fprintf(stderr, "Nieprawidlowa wielkosc bufora\n");
				exit(EXIT_FAILURE);
			}
		} else {
			fprintf(stderr, "Nieprawidlowa opcja: %c\n", c);
			exit(EXIT_FAILURE);
		}
	}
	if ((optind+2) != argc) {
		fprintf(stderr, "Nieprawidlowa ilosc argumentow\n");
		exit(EXIT_FAILURE);
	}
	
	if (! cpy(argv[optind], argv[optind+1]))
		exit(EXIT_FAILURE);
	exit(0);
}
